@ Procedure for panel unit root test for
   "Dynamic Panel Estimation and Homogeneity Testing Under
                  Cross Section Dependence" 
                           by 
            Peter C.B. Phillips and Donggyu Sul
            Econometrics Journal 2003, Vol 6. pp 217260
            

                        Programmed by
                         Donggyu Sul
                  This version: Dec 14, 2004

             I CHECKED THE PRORGRAM and FIND NO ERROR BUT
         PLEASE LET ME KNOW if THERE IS ANY PROGRAMMING ERROR.
    
  Usage: 
     
   {gg1,gg2,mt1,bn,gz1} = punit1(y,cq,p,ioption);
   
   Input:
     y = NxT data matrix
     cq = ADF critical values
     p = the maximum order. (the procedure automatically choose the lag length of
                             ADF regressions based on top-down method)
     ioption = 1 for constant, 2 for linear trend.
   
   output:
   
     gg1 = Nx1 ADF t ratio (univariate result)
     gg2 = Nx1 p-value for individual ADF t test
     mt1 = variance and covariance matrix of the panel regression residuals
     bn  = estimated factor loading coefficient by IMM
     gz1 = Fisher Z-test distributed as Chi-square 2x(N-1) degrees of freedom.
@

@ ================ Example =========================================@

seed = 120349;
k = rndns(100,20,seed);
e = rndns(100,1,seed);
a = 1 + rndus(1,20,seed).*3;
u = a.*e + k;

y = u;
i = 2;
do while i <= 100;
 y[i,.] = y[i-1,.] + u[i,.];
i = i + 1;
endo;

load adfc[199,13] = adftc.csv;
load adft[199,13] = adftt.csv;

@Sample size 30(2),40(3),50(4),60(5),70(6),80(7),90(8),100(9),125(10),150(11),175(12),200(13) @

cq = adfc[.,9]; @ T= 100 @

   {gg1,gg2,mt1,bn,gz1} = punit1(y,cq,5,1);
"univariate test results";
" adf t-ratio  p-value";
   gg1~gg2;
" Z-test  p-value ";
   gz1~cdfchic(gz1,(cols(y)-1)*2);

@======================= end of Example ================================@



@ ====================== Procedure starts ==============================@


proc (5) = punit1(y,cq,p,ioption);
local t,n,re,indx,mt1,cre,aq,i,bn,dd1;
local ss,rs1,dd3,dd5,ff1,fd1,kk1,ffd1,fq1,fd3;
local yy,pp1,pp2,gc2,hn1,gz1,gn1,iccco;
local ggg,gg1,gg2,kk;

kk = rows(cq);

t = rows(y);
n = cols(y);
 {indx} = detlag(y,p,ioption);
 gg1 = zeros(n,1);
 gg2 = gg1;
 i = 1;
 do while i <= n;
   gg1[i] = suladf(y[.,i],indx[i],ioption);
   gg2[i] = minindc(abs(cq - gg1[i]))/kk;
 i = i + 1;
 endo;

 {re,indx} = detlagnc(y,p,ioption);
  mt1 = re're./(rows(re)-1);
  cre = meanc(re');
  cre = invpd(cre'cre)*cre';
  aq  = zeros(1,n);
  i = 1;
  do while i <= n;
   aq[i] = cre*re[.,i];
  i = i + 1;
  endo;

   iccco = 1;
   dasi:

   bn = imm(mt1,aq);
  if maxc(abs(bn'-aq')) > 0.0000001 and iccco < 160; aq = bn;
   goto dasi; endif;
   dd1 = bn';

    ss = diag(re're)./(rows(re)-1);
   rs1 = ss.*eye(n) - (dd1.*dd1).*eye(n);
   dd3 = dd1*inv(dd1'dd1)*dd1';
   dd5 = eye(n) - dd3;
  {ff1,fd1} = eigrs2(dd5);
    kk1 = minindc(ff1);
  if kk1 > 1;
     ffd1 = fd1[.,1:kk1-1]~fd1[.,kk1+1:n];
  else;
     ffd1 = fd1[.,2:n]; endif;
  fd1 = ffd1;
  fq1 = det(fd1'rs1*fd1);
  fd3 = inv(fd1'rs1*fd1);
  fd3 = chol(fd3);
  fd3 = fd3*fd1';

  yy  = fd3*y'; yy = yy';
  indx = detlag(yy,p,ioption);
  pp1 = zeros(n-1,1);
  pp2 = pp1;

   i = 1;
   do while i <= n-1;
     gc2 = suladf(yy[.,i],indx[i],ioption);
     pp1[i] = minindc(abs(cq - gc2))/kk;
   i = i + 1;
   endo;

     gz1 = sumc(ln(pp1))*(-2);

retp(gg1,gg2,mt1,bn,gz1);
endp;


proc pemu(x,ww);
local be1, k, be2,cr;
cr = ww;
be1 = x;
if be1 > cr[rows(cr),2]; be2 = 1; goto ttt; endif;
k = minindc(abs(be1 - cr[.,2]));
be2 = cr[k,1];
ttt:
retp(be2);
endp;

proc (1) = imm(mt,b);
 local n,i,j,sum1,sum2;
 n = cols(mt);
 sum1 = 0;
 sum2 = 0;
 b[1] = sumc( (mt[1,2:n].*b[2:n])')./(sumc( (b[2:n].*b[2:n])'));
 i = 2;
 do while i <= n-1;
   sum1 = sumc( (mt[i,1:i-1].*b[1:i-1])')+ sumc( (mt[i,i+1:n].*b[i+1:n])');
   sum2 = sumc( (b[1:i-1].*b[1:i-1])') + sumc( (b[i+1:n].*b[i+1:n])');
   b[i] = sum1/sum2;
 i = i + 1;
 endo;
   b[n] = sumc( (mt[n,1:n-1].*b[1:n-1])')./(sumc( (b[1:n-1].*b[1:n-1])'));
retp(b);
endp;


proc (2) = lagp(x,p);
local t,i,xx,dx,y,rio;
t = rows(x);

if p == 1;
y = x[2:t,.]; x = x[1:t-1,.]; goto rio; endif;

xx = zeros(t-p,p+1);
dx = zeros(t-p,p-1);

i = 0; do while i <= p;
xx[.,i+1] = x[p+1-i:t-i,.];
i = i + 1; endo;

i = 1; do while i <= p-1;
dx[.,p-i] = xx[.,p-(i-1)] - xx[.,p+1-(i-1)];
i = i + 1; endo;

y = xx[.,1];  x = xx[.,2]~dx;
rio:
retp(y,x); endp;

proc (2) = detlagnc(s,pp,icoption);
local i,ss,i1,y,x,const, b, resi,s_s,se,t_last, rio,n;
local indx, resid,td,tt;

n = cols(s);
indx = ones(n,1);
{y,x} = lagp1(s[.,1],pp);
tt = rows(y);

resid = zeros(tt,n);

i = 1;
do while i <= n;
ss = s[.,i];

i1 = pp;
do while i1 >= 2;

{y,x} = lagp1(ss,i1);
const = ones(rows(y),1);
if icoption == 1; x = x; endif;
if icoption == 2; x = const~x; endif;
b = inv(x'x)*x'y;
resi = y - x*b;
s_s = resi'resi/(rows(y) - rows(b) );
se  = sqrt(diag(s_s*inv(x'x)));
t_last = abs(b[rows(b),1]/se[rows(se),1]);
if t_last >= 1.96; indx[i,1] = i1; goto rio; endif;

i1 = i1 -1;
endo;
rio:

td = rows(resi) - tt + 1;

resid[.,i] = resi[td:rows(resi)];
i = i + 1;
endo;
retp(resid,indx);
endp;




proc (2) = lagp1(x,p);
local t,i,xx,dx,y,rio;
t = rows(x);
if p == 1; y = x[2:t,.] - x[1:t-1,.]; x = zeros(t-1,1); goto rio; endif;
xx = zeros(t-p,p+1);dx = zeros(t-p,p-1);

i = 0;do while i <= p;
xx[.,i+1] = x[p+1-i:t-i,.];
i = i + 1;endo;

i = 1;do while i <= p-1;
dx[.,p-i] = xx[.,p-(i-1)] - xx[.,p+1-(i-1)];
i = i + 1;endo;

y = xx[.,1] - xx[.,2];
x = dx; rio:
retp(y,x); endp;

proc suladf(f,p,option);
local y,x,beta,resi,ss,var_cov,va;
 {y, x} = lagp(f,p);
if option == 1;  x = x~ones(rows(x),1); endif;
if option == 2;  x = x~ones(rows(x),1)~seqa(1,1,rows(x)); endif;
 beta = inv(x'x)*x'y;
 resi = y - x*beta;
 ss   = (resi'resi)/(rows(y) - cols(x));
 var_cov = ss*inv(x'x);
 va = (beta[1,1] - 1)/sqrt(var_cov[1,1]);
retp(va);
endp;

proc detlag(s,pp,icoption);
local i,ss,i1,y,x,const, b, resi,s_s,se,t_last, rio,n;
local indx;

n = cols(s);
indx = ones(n,1);
i = 1;
do while i <= n;
ss = s[.,i];

i1 = pp;
do while i1 >= 2;

{y,x} = lagp(ss,i1);
const = ones(rows(y),1);
if icoption == 1; x = const~x; endif;
if icoption == 2; x = const~seqa(1,1,rows(x))~x; endif;
b = inv(x'x)*x'y;
resi = y - x*b;
s_s = resi'resi/(rows(y) - rows(b) );
se  = sqrt(diag(s_s*inv(x'x)));
t_last = abs(b[rows(b),1]/se[rows(se),1]);
if t_last >= 1.96; indx[i,1] = i1; goto rio; endif;

i1 = i1 -1;
endo;
rio:

i = i + 1;
endo;
retp(indx);
endp;

proc offdiag(x);
local t,n,z,i,j;

t = rows(x);
n = cols(x);
z = {};
 i = 2;
 do while i <= n-1;
   j = i+1;
   do while j <= n;
     z = z~x[i,j];
   j = j + 1;
   endo;
 i = i + 1;
 endo;
retp(z);
endp;


